/*
 * Copyright (c) 2023 Xilinx
 * This package is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.

 * This package is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this package; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifndef __GST_AMA_ENC_H__
#define __GST_AMA_ENC_H__

#include <gst/video/gstvideoencoder.h>

#include <xmaencoder.h>

G_BEGIN_DECLS

#define GST_AMA_ENC_RANGED_PROPERTY_FIRST 50

#define GST_TYPE_AMA_ENC (gst_ama_enc_get_type ())
G_DECLARE_DERIVABLE_TYPE (GstAMAEnc, gst_ama_enc, GST, AMA_ENC, GstVideoEncoder)

struct _GstAMAEncClass
{
  GstVideoEncoderClass parent_class;

  guint32 qp_max;
  gint32 min_qp_max;
  gint32 max_qp_max;
  gint32 max_qp_default;
  guint32 b_frames_max;

  void (*configure_encoder) (GstAMAEnc *self, GstCaps *outcaps,
      XmaEncoderProperties *enc_props);
};

void gst_ama_enc_class_init_ranged_properties (GstAMAEncClass *amaenc_class);

G_END_DECLS

#endif /* __GST_AMA_ENC_H__ */
